org.jsr166

## Class ConcurrentHashMap8<K,V>

- java.lang.Object
- - org.jsr166.ConcurrentHashMap8<K,V>

Type Parameters:
  `K` - the type of keys maintained by this map
  `V` - the type of mapped values

All Implemented Interfaces:
  Serializable, ConcurrentMap<K,V>, Map<K,V>

Direct Known Subclasses:
  ClusterNodeLocalMapImpl, GridSynchronizedMap

    public class ConcurrentHashMap8<K,V>
    extends Object
    implements ConcurrentMap<K,V>, Serializable

A hash table supporting full concurrency of retrievals and high expected concurrency for updates. This class obeys the same functional specification as `Hashtable`, and includes versions of methods corresponding to each method of `Hashtable`. However, even though all operations are thread-safe, retrieval operations do not entail locking, and there is not any support for locking the entire table in a way that prevents all access. This class is fully interoperable with `Hashtable` in programs that rely on its thread safety but not on its synchronization details.

Retrieval operations (including `get`) generally do not block, so may overlap with update operations (including `put` and `remove`). Retrievals reflect the results of the most recently completed update operations holding upon their onset. (More formally, an update operation for a given key bears a happens-before relation with any (non-null) retrieval for that key reporting the updated value.) For aggregate operations such as `putAll` and `clear`, concurrent retrievals may reflect insertion or removal of only some entries. Similarly, Iterators and Enumerations return elements reflecting the state of the hash table at some point at or since the creation of the iterator/enumeration. They do not throw `ConcurrentModificationException`. However, iterators are designed to be used by only one thread at a time. Bear in mind that the results of aggregate status methods including `size`, `isEmpty`, and `containsValue` are typically useful only when a map is not undergoing concurrent updates in other threads. Otherwise the results of these methods reflect transient states that may be adequate for monitoring or estimation purposes, but not for program control.

The table is dynamically expanded when there are too many collisions (i.e., keys that have distinct hash codes but fall into the same slot modulo the table size), with the expected average effect of maintaining roughly two bins per mapping (corresponding to a 0.75 load factor threshold for resizing). There may be much variance around this average as mappings are added and removed, but overall, this maintains a commonly accepted time/space tradeoff for hash tables. However, resizing this or any other kind of hash table may be a relatively slow operation. When possible, it is a good idea to provide a size estimate as an optional `initialCapacity` constructor argument. An additional optional `loadFactor` constructor argument provides a further means of customizing initial table capacity by specifying the table density to be used in calculating the amount of space to allocate for the given number of elements. Also, for compatibility with previous versions of this class, constructors may optionally specify an expected `concurrencyLevel` as an additional hint for internal sizing. Note that using many keys with exactly the same `hashCode()` is a sure way to slow down performance of any hash table.

A `Set` projection of a ConcurrentHashMapV8 may be created (using `newKeySet()` or `newKeySet(int)`), or viewed (using `keySet(Object)` when only keys are of interest, and the mapped values are (perhaps transiently) not used or all take the same mapping value.

A ConcurrentHashMapV8 can be used as scalable frequency map (a form of histogram or multiset) by using `LongAdder8` values and initializing via `computeIfAbsent(K, org.jsr166.ConcurrentHashMap8.Fun<? super K, ? extends V>)`. For example, to add a count to a `ConcurrentHashMapV8<String,LongAdder8> freqs`, you can use `freqs.computeIfAbsent(k -> new LongAdder8()).increment();`

This class and its views and iterators implement all of the optional methods of the `Map` and `Iterator` interfaces.

Like `Hashtable` but unlike `HashMap`, this class does not allow `null` to be used as a key or value.

- forEach: Perform a given action on each element. A variant form applies a given transformation on each element before performing the action.
- search: Return the first available non-null result of applying a given function on each element; skipping further search when a result is found.
- reduce: Accumulate each element. The supplied reduction function cannot rely on ordering (more formally, it should be both associative and commutative). There are five variants:
  - Plain reductions. (There is not a form of this method for (key, value) function arguments since there is no corresponding return type.)
  - Mapped reductions that accumulate the results of a given function applied to each element.
  - Reductions to scalar doubles, longs, and ints, using a given basis value.

The concurrency properties of bulk operations follow from those of ConcurrentHashMapV8: Any non-null result returned from `get(key)` and related access methods bears a happens-before relation with the associated insertion or update. The result of any bulk operation reflects the composition of these per-element relations (but is not necessarily atomic with respect to the map as a whole unless it is somehow known to be quiescent). Conversely, because keys and values in the map are never null, null serves as a reliable atomic indicator of the current lack of any result. To maintain this property, null serves as an implicit basis for all non-scalar reduction operations. For the double, long, and int versions, the basis should be one that, when combined with any other value, returns that other value (more formally, it should be the identity element for the reduction). Most common reductions have these properties; for example, computing a sum with basis 0 or a minimum with basis MAX_VALUE.

Search and transformation functions provided as arguments should similarly return null to indicate the lack of any result (in which case it is not used). In the case of mapped reductions, this also enables transformations to serve as filters, returning null (or, in the case of primitive specializations, the identity basis) if the element should not be combined. You can create compound transformations and filterings by composing them yourself under this "null means there is nothing there now" rule before using them in search or reduce operations.

Methods accepting and/or returning Entry arguments maintain key-value associations. They may be useful for example when finding the key for the greatest value. Note that "plain" Entry arguments can be supplied using `new AbstractMap.SimpleEntry(k,v)`.

Bulk operations may complete abruptly, throwing an exception encountered in the application of a supplied function. Bear in mind when handling such exceptions that other concurrently executing functions could also have thrown exceptions, or would have done so if the first exception had not occurred.

Parallel speedups for bulk operations compared to sequential processing are common but not guaranteed. Operations involving brief functions on small maps may execute more slowly than sequential loops if the underlying work to parallelize the computation is more expensive than the computation itself. Similarly, parallelization may not lead to much actual parallelism if all processors are busy performing unrelated tasks.

All arguments to all task methods must be non-null.

jsr166e note: During transition, this class uses nested functional interfaces with different names but the same forms as those expected for JDK8.

Since:
  1.5
See Also:
  Serialized Form

### Nested Class Summary

Nested Classes
`static interface` `ConcurrentHashMap8.Action<A>` Interface describing a void action of one argument
`static interface` `ConcurrentHashMap8.BiAction<A,B>` Interface describing a void action of two arguments
`static interface` `ConcurrentHashMap8.BiFun<A,B,T>` Interface describing a function of two arguments
`static interface` `ConcurrentHashMap8.DoubleByDoubleToDouble` Interface describing a function mapping two doubles to a double
`static interface` `ConcurrentHashMap8.DoubleToDouble` Interface describing a function mapping a double to a double
`static class` `ConcurrentHashMap8.EntrySetView<K,V>` A view of a ConcurrentHashMapV8 as a `Set` of (key, value) entries.
`static interface` `ConcurrentHashMap8.Fun<A,T>` Interface describing a function of one argument
`static interface` `ConcurrentHashMap8.Generator<T>` Interface describing a function of no arguments
`static interface` `ConcurrentHashMap8.IntByIntToInt` Interface describing a function mapping two ints to an int
`static interface` `ConcurrentHashMap8.IntToInt` Interface describing a function mapping an int to an int
`static class` `ConcurrentHashMap8.KeySetView<K,V>` A view of a ConcurrentHashMapV8 as a `Set` of keys, in which additions may optionally be enabled by mapping to a common value.
`static interface` `ConcurrentHashMap8.LongByLongToLong` Interface describing a function mapping two longs to a long
`static interface` `ConcurrentHashMap8.LongToLong` Interface describing a function mapping a long to a long
`static interface` `ConcurrentHashMap8.ObjectByObjectToDouble<A,B>` Interface describing a function mapping two arguments to a double
`static interface` `ConcurrentHashMap8.ObjectByObjectToInt<A,B>` Interface describing a function mapping two arguments to an int
`static interface` `ConcurrentHashMap8.ObjectByObjectToLong<A,B>` Interface describing a function mapping two arguments to a long
`static interface` `ConcurrentHashMap8.ObjectToDouble<A>` Interface describing a function mapping its argument to a double
`static interface` `ConcurrentHashMap8.ObjectToInt<A>` Interface describing a function mapping its argument to an int
`static interface` `ConcurrentHashMap8.ObjectToLong<A>` Interface describing a function mapping its argument to a long
`static interface` `ConcurrentHashMap8.Spliterator<T>` A partitionable iterator.
`static class` `ConcurrentHashMap8.ValuesView<K,V>` A view of a ConcurrentHashMapV8 as a `Collection` of values, in which additions are disabled.

### Nested classes/interfaces inherited from interface java.util.Map

`Map.Entry<K,V>`

### Constructor Summary

Constructors
Constructor and Description
`ConcurrentHashMap8()` Creates a new, empty map with the default initial table size (16).
`ConcurrentHashMap8(int initialCapacity)` Creates a new, empty map with an initial table size accommodating the specified number of elements without the need to dynamically resize.
`ConcurrentHashMap8(int initialCapacity, float loadFactor)` Creates a new, empty map with an initial table size based on the given number of elements (`initialCapacity`) and initial table density (`loadFactor`).
`ConcurrentHashMap8(int initialCapacity, float loadFactor, int concurrencyLevel)` Creates a new, empty map with an initial table size based on the given number of elements (`initialCapacity`), table density (`loadFactor`), and number of concurrently updating threads (`concurrencyLevel`).
`ConcurrentHashMap8(Map<? extends K,? extends V> m)` Creates a new map with the same mappings as the given map.

### Method Summary

Methods
`void` `clear()` Removes all of the mappings from this map.
`V` `compute(K key, ConcurrentHashMap8.BiFun<? super K,? super V,? extends V> remappingFunction)` Computes a new mapping value given a key and its current mapped value (or `null` if there is no current mapping).
`V` `computeIfAbsent(K key, ConcurrentHashMap8.Fun<? super K,? extends V> mappingFunction)` If the specified key is not already associated with a value, computes its value using the given mappingFunction and enters it into the map unless null.
`V` `computeIfPresent(K key, ConcurrentHashMap8.BiFun<? super K,? super V,? extends V> remappingFunction)` If the given key is present, computes a new mapping value given a key and its current mapped value.
`boolean` `contains(Object value)` Legacy method testing if some key maps into the specified value in this table.
`boolean` `containsKey(Object key)` Tests if the specified object is a key in this table.
`boolean` `containsValue(Object value)` Returns `true` if this map maps one or more keys to the specified value.
`Enumeration<V>` `elements()` Returns an enumeration of the values in this table.
`Set<Map.Entry<K,V>>` `entrySet()` Returns a `Set` view of the mappings contained in this map.
`ConcurrentHashMap8.Spliterator<Map.Entry<K,V>>` `entrySpliterator()` Returns a partitionable iterator of the entries in this map.
`boolean` `equals(Object o)` Compares the specified object with this map for equality.
`V` `get(Object key)` Returns the value to which the specified key is mapped, or `null` if this map contains no mapping for the key.
`V` `getValueOrDefault(Object key, V defaultValue)` Returns the value to which the specified key is mapped, or the given defaultValue if this map contains no mapping for the key.
`int` `hashCode()` Returns the hash code value for this `Map`, i.e., the sum of, for each key-value pair in the map, `key.hashCode() ^ value.hashCode()`.
`boolean` `isEmpty()`
`Enumeration<K>` `keys()` Returns an enumeration of the keys in this table.
`ConcurrentHashMap8.KeySetView<K,V>` `keySet()` Returns a `Set` view of the keys contained in this map.
`ConcurrentHashMap8.KeySetView<K,V>` `keySet(V mappedValue)` Returns a `Set` view of the keys in this map, using the given common mapped value for any additions (i.e., `Collection.add(E)` and `Collection.addAll(java.util.Collection<? extends E>)`).
`ConcurrentHashMap8.Spliterator<K>` `keySpliterator()` Returns a partitionable iterator of the keys in this map.
`long` `mappingCount()` Returns the number of mappings.
`V` `merge(K key, V value, ConcurrentHashMap8.BiFun<? super V,? super V,? extends V> remappingFunction)` If the specified key is not already associated with a value, associate it with the given value.
`static <K> ConcurrentHashMap8.KeySetView<K,Boolean>` `newKeySet()` Creates a new `Set` backed by a ConcurrentHashMapV8 from the given type to `Boolean.TRUE`.
`static <K> ConcurrentHashMap8.KeySetView<K,Boolean>` `newKeySet(int initialCapacity)` Creates a new `Set` backed by a ConcurrentHashMapV8 from the given type to `Boolean.TRUE`.
`V` `put(K key, V value)` Maps the specified key to the specified value in this table.
`void` `putAll(Map<? extends K,? extends V> m)` Copies all of the mappings from the specified map to this one.
`V` `putIfAbsent(K key, V value)`
`V` `remove(Object key)` Removes the key (and its corresponding value) from this map.
`boolean` `remove(Object key, Object value)`
`V` `replace(K key, V value)`
`boolean` `replace(K key, V oldValue, V newValue)`
`int` `size()`
`String` `toString()` Returns a string representation of this map.
`ConcurrentHashMap8.ValuesView<K,V>` `values()` Returns a `Collection` view of the values contained in this map.
`ConcurrentHashMap8.Spliterator<V>` `valueSpliterator()` Returns a partitionable iterator of the values in this map.

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### ConcurrentHashMap8

    public ConcurrentHashMap8()

Creates a new, empty map with the default initial table size (16).

#### ConcurrentHashMap8

    public ConcurrentHashMap8(int initialCapacity)

Creates a new, empty map with an initial table size accommodating the specified number of elements without the need to dynamically resize.

Parameters:
  `initialCapacity` - The implementation performs internal sizing to accommodate this many elements.
Throws:
  `IllegalArgumentException` - if the initial capacity of elements is negative

#### ConcurrentHashMap8

    public ConcurrentHashMap8(Map<? extends K,? extends V> m)

Creates a new map with the same mappings as the given map.

Parameters:
  `m` - the map

#### ConcurrentHashMap8

    public ConcurrentHashMap8(int initialCapacity,
                      float loadFactor)

Creates a new, empty map with an initial table size based on the given number of elements (`initialCapacity`) and initial table density (`loadFactor`).

Parameters:
  `initialCapacity` - the initial capacity. The implementation performs internal sizing to accommodate this many elements, given the specified load factor.
  `loadFactor` - the load factor (table density) for establishing the initial table size
Throws:
  `IllegalArgumentException` - if the initial capacity of elements is negative or the load factor is nonpositive
Since:
  1.6

#### ConcurrentHashMap8

    public ConcurrentHashMap8(int initialCapacity,
                      float loadFactor,
                      int concurrencyLevel)

Creates a new, empty map with an initial table size based on the given number of elements (`initialCapacity`), table density (`loadFactor`), and number of concurrently updating threads (`concurrencyLevel`).

Parameters:
  `initialCapacity` - the initial capacity. The implementation performs internal sizing to accommodate this many elements, given the specified load factor.
  `loadFactor` - the load factor (table density) for establishing the initial table size
  `concurrencyLevel` - the estimated number of concurrently updating threads. The implementation may use this value as a sizing hint.
Throws:
  `IllegalArgumentException` - if the initial capacity is negative or the load factor or concurrencyLevel are nonpositive

### Method Detail

#### newKeySet

    public static <K> ConcurrentHashMap8.KeySetView<K,Boolean> newKeySet()

Creates a new `Set` backed by a ConcurrentHashMapV8 from the given type to `Boolean.TRUE`.

Returns:
  the new set

#### newKeySet

    public static <K> ConcurrentHashMap8.KeySetView<K,Boolean> newKeySet(int initialCapacity)

Creates a new `Set` backed by a ConcurrentHashMapV8 from the given type to `Boolean.TRUE`.

Parameters:
  `initialCapacity` - The implementation performs internal sizing to accommodate this many elements.
Returns:
  the new set
Throws:
  `IllegalArgumentException` - if the initial capacity of elements is negative

#### isEmpty

    public boolean isEmpty()

Specified by:
  `isEmpty` in interface `Map<K,V>`

#### size

    public int size()

Specified by:
  `size` in interface `Map<K,V>`

#### mappingCount

    public long mappingCount()

Returns the number of mappings. This method should be used instead of `size()` because a ConcurrentHashMapV8 may contain more mappings than can be represented as an int. The value returned is an estimate; the actual count may differ if there are concurrent insertions or removals.

Returns:
  the number of mappings

#### get

    public V get(Object key)

Returns the value to which the specified key is mapped, or `null` if this map contains no mapping for the key.

More formally, if this map contains a mapping from a key `k` to a value `v` such that `key.equals(k)`, then this method returns `v`; otherwise it returns `null`. (There can be at most one such mapping.)

Specified by:
  `get` in interface `Map<K,V>`
Throws:
  `NullPointerException` - if the specified key is null

#### getValueOrDefault

    public V getValueOrDefault(Object key,
                      V defaultValue)

Returns the value to which the specified key is mapped, or the given defaultValue if this map contains no mapping for the key.

Parameters:
  `key` - the key
  `defaultValue` - the value to return if this map contains no mapping for the given key
Returns:
  the mapping for the key, if present; else the defaultValue
Throws:
  `NullPointerException` - if the specified key is null

#### containsKey

    public boolean containsKey(Object key)

Tests if the specified object is a key in this table.

Specified by:
  `containsKey` in interface `Map<K,V>`
Parameters:
  `key` - possible key
Returns:
  `true` if and only if the specified object is a key in this table, as determined by the `equals` method; `false` otherwise
Throws:
  `NullPointerException` - if the specified key is null

#### containsValue

    public boolean containsValue(Object value)

Returns `true` if this map maps one or more keys to the specified value. Note: This method may require a full traversal of the map, and is much slower than method `containsKey`.

Specified by:
  `containsValue` in interface `Map<K,V>`
Parameters:
  `value` - value whose presence in this map is to be tested
Returns:
  `true` if this map maps one or more keys to the specified value
Throws:
  `NullPointerException` - if the specified value is null

#### contains

    public boolean contains(Object value)

Legacy method testing if some key maps into the specified value in this table. This method is identical in functionality to `containsValue(java.lang.Object)`, and exists solely to ensure full compatibility with class `Hashtable`, which supported this method prior to introduction of the Java Collections framework.

Parameters:
  `value` - a value to search for
Returns:
  `true` if and only if some key maps to the `value` argument in this table as determined by the `equals` method; `false` otherwise
Throws:
  `NullPointerException` - if the specified value is null

#### put

    public V put(K key,
        V value)

Maps the specified key to the specified value in this table. Neither the key nor the value can be null.

The value can be retrieved by calling the `get` method with a key that is equal to the original key.

Specified by:
  `put` in interface `Map<K,V>`
Parameters:
  `key` - key with which the specified value is to be associated
  `value` - value to be associated with the specified key
Returns:
  the previous value associated with `key`, or `null` if there was no mapping for `key`
Throws:
  `NullPointerException` - if the specified key or value is null

#### putIfAbsent

    public V putIfAbsent(K key,
                V value)

Specified by:
  `putIfAbsent` in interface `ConcurrentMap<K,V>`
Returns:
  the previous value associated with the specified key, or `null` if there was no mapping for the key
Throws:
  `NullPointerException` - if the specified key or value is null

#### putAll

    public void putAll(Map<? extends K,? extends V> m)

Copies all of the mappings from the specified map to this one. These mappings replace any mappings that this map had for any of the keys currently in the specified map.

Specified by:
  `putAll` in interface `Map<K,V>`
Parameters:
  `m` - mappings to be stored in this map

#### computeIfAbsent

    public V computeIfAbsent(K key,
                    ConcurrentHashMap8.Fun<? super K,? extends V> mappingFunction)

If the specified key is not already associated with a value, computes its value using the given mappingFunction and enters it into the map unless null. This is equivalent to

     if (map.containsKey(key))
       return map.get(key);
     value = mappingFunction.apply(key);
     if (value != null)
       map.put(key, value);
     return value;

except that the action is performed atomically. If the function returns `null` no mapping is recorded. If the function itself throws an (unchecked) exception, the exception is rethrown to its caller, and no mapping is recorded. Some attempted update operations on this map by other threads may be blocked while computation is in progress, so the computation should be short and simple, and must not attempt to update any other mappings of this Map. The most appropriate usage is to construct a new object serving as an initial mapped value, or memoized result, as in:

     map.computeIfAbsent(key, new Fun<K, V>() {
       public V map(K k) { return new Value(f(k)); }});

Parameters:
  `key` - key with which the specified value is to be associated
  `mappingFunction` - the function to compute a value
Returns:
  the current (existing or computed) value associated with the specified key, or null if the computed value is null
Throws:
  `NullPointerException` - if the specified key or mappingFunction is null
  `IllegalStateException` - if the computation detectably attempts a recursive update to this map that would otherwise never complete
  `RuntimeException` - or Error if the mappingFunction does so, in which case the mapping is left unestablished

#### computeIfPresent

    public V computeIfPresent(K key,
                     ConcurrentHashMap8.BiFun<? super K,? super V,? extends V> remappingFunction)

If the given key is present, computes a new mapping value given a key and its current mapped value. This is equivalent to

     if (map.containsKey(key)) {
         value = remappingFunction.apply(key, map.get(key));
         if (value != null)
           map.put(key, value);
         else
           map.remove(key);
       }

except that the action is performed atomically. If the function returns `null`, the mapping is removed. If the function itself throws an (unchecked) exception, the exception is rethrown to its caller, and the current mapping is left unchanged. Some attempted update operations on this map by other threads may be blocked while computation is in progress, so the computation should be short and simple, and must not attempt to update any other mappings of this Map. For example, to either create or append new messages to a value mapping:

Parameters:
  `key` - key with which the specified value is to be associated
  `remappingFunction` - the function to compute a value
Returns:
  the new value associated with the specified key, or null if none
Throws:
  `NullPointerException` - if the specified key or remappingFunction is null
  `IllegalStateException` - if the computation detectably attempts a recursive update to this map that would otherwise never complete
  `RuntimeException` - or Error if the remappingFunction does so, in which case the mapping is unchanged

#### compute

    public V compute(K key,
            ConcurrentHashMap8.BiFun<? super K,? super V,? extends V> remappingFunction)

Computes a new mapping value given a key and its current mapped value (or `null` if there is no current mapping). This is equivalent to

     value = remappingFunction.apply(key, map.get(key));
       if (value != null)
         map.put(key, value);
       else
         map.remove(key);

except that the action is performed atomically. If the function returns `null`, the mapping is removed. If the function itself throws an (unchecked) exception, the exception is rethrown to its caller, and the current mapping is left unchanged. Some attempted update operations on this map by other threads may be blocked while computation is in progress, so the computation should be short and simple, and must not attempt to update any other mappings of this Map. For example, to either create or append new messages to a value mapping:

     Map<Key, String> map = ...;
     final String msg = ...;
     map.compute(key, new BiFun<Key, String, String>() {
       public String apply(Key k, String v) {
        return (v == null) ? msg : v + msg;});}

Parameters:
  `key` - key with which the specified value is to be associated
  `remappingFunction` - the function to compute a value
Returns:
  the new value associated with the specified key, or null if none
Throws:
  `NullPointerException` - if the specified key or remappingFunction is null
  `IllegalStateException` - if the computation detectably attempts a recursive update to this map that would otherwise never complete
  `RuntimeException` - or Error if the remappingFunction does so, in which case the mapping is unchanged

#### merge

    public V merge(K key,
          V value,
          ConcurrentHashMap8.BiFun<? super V,? super V,? extends V> remappingFunction)

If the specified key is not already associated with a value, associate it with the given value. Otherwise, replace the value with the results of the given remapping function. This is equivalent to:

     if (!map.containsKey(key))
         map.put(value);
       else {
         newValue = remappingFunction.apply(map.get(key), value);
         if (value != null)
           map.put(key, value);
         else
           map.remove(key);
       }

except that the action is performed atomically. If the function returns `null`, the mapping is removed. If the function itself throws an (unchecked) exception, the exception is rethrown to its caller, and the current mapping is left unchanged. Some attempted update operations on this map by other threads may be blocked while computation is in progress, so the computation should be short and simple, and must not attempt to update any other mappings of this Map.

#### remove

    public V remove(Object key)

Removes the key (and its corresponding value) from this map. This method does nothing if the key is not in the map.

Specified by:
  `remove` in interface `Map<K,V>`
Parameters:
  `key` - the key that needs to be removed
Returns:
  the previous value associated with `key`, or `null` if there was no mapping for `key`
Throws:
  `NullPointerException` - if the specified key is null

#### remove

    public boolean remove(Object key,
                 Object value)

Specified by:
  `remove` in interface `ConcurrentMap<K,V>`
Throws:
  `NullPointerException` - if the specified key is null

#### replace

    public boolean replace(K key,
                  V oldValue,
                  V newValue)

Specified by:
  `replace` in interface `ConcurrentMap<K,V>`
Throws:
  `NullPointerException` - if any of the arguments are null

#### replace

    public V replace(K key,
            V value)

Specified by:
  `replace` in interface `ConcurrentMap<K,V>`
Returns:
  the previous value associated with the specified key, or `null` if there was no mapping for the key
Throws:
  `NullPointerException` - if the specified key or value is null

#### clear

    public void clear()

Removes all of the mappings from this map.

Specified by:
  `clear` in interface `Map<K,V>`

#### keySet

    public ConcurrentHashMap8.KeySetView<K,V> keySet()

Returns a `Set` view of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa.

Specified by:
  `keySet` in interface `Map<K,V>`
Returns:
  the set view

#### keySet

    public ConcurrentHashMap8.KeySetView<K,V> keySet(V mappedValue)

Returns a `Set` view of the keys in this map, using the given common mapped value for any additions (i.e., `Collection.add(E)` and `Collection.addAll(java.util.Collection<? extends E>)`). This is of course only appropriate if it is acceptable to use the same value for all additions from this view.

Parameters:
  `mappedValue` - the mapped value to use for any additions.
Returns:
  the set view
Throws:
  `NullPointerException` - if the mappedValue is null

#### values

    public ConcurrentHashMap8.ValuesView<K,V> values()

Returns a `Collection` view of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa.

Specified by:
  `values` in interface `Map<K,V>`

#### entrySet

    public Set<Map.Entry<K,V>> entrySet()

Returns a `Set` view of the mappings contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

The view's `iterator` is a "weakly consistent" iterator that will never throw `ConcurrentModificationException`, and guarantees to traverse elements as they existed upon construction of the iterator, and may (but is not guaranteed to) reflect any modifications subsequent to construction.

Specified by:
  `entrySet` in interface `Map<K,V>`

#### keys

    public Enumeration<K> keys()

Returns an enumeration of the keys in this table.

Returns:
  an enumeration of the keys in this table
See Also:
  `keySet()`

#### elements

    public Enumeration<V> elements()

Returns an enumeration of the values in this table.

Returns:
  an enumeration of the values in this table
See Also:
  `values()`

#### keySpliterator

    public ConcurrentHashMap8.Spliterator<K> keySpliterator()

Returns a partitionable iterator of the keys in this map.

Returns:
  a partitionable iterator of the keys in this map

#### valueSpliterator

    public ConcurrentHashMap8.Spliterator<V> valueSpliterator()

Returns a partitionable iterator of the values in this map.

Returns:
  a partitionable iterator of the values in this map

#### entrySpliterator

    public ConcurrentHashMap8.Spliterator<Map.Entry<K,V>> entrySpliterator()

Returns a partitionable iterator of the entries in this map.

Returns:
  a partitionable iterator of the entries in this map

#### hashCode

    public int hashCode()

Returns the hash code value for this `Map`, i.e., the sum of, for each key-value pair in the map, `key.hashCode() ^ value.hashCode()`.

Specified by:
  `hashCode` in interface `Map<K,V>`
Overrides:
  `hashCode` in class `Object`
Returns:
  the hash code value for this map

#### toString

    public String toString()

Returns a string representation of this map. The string representation consists of a list of key-value mappings (in no particular order) enclosed in braces ("`{}`"). Adjacent mappings are separated by the characters `", "` (comma and space). Each key-value mapping is rendered as the key followed by an equals sign ("`=`") followed by the associated value.

Overrides:
  `toString` in class `Object`
Returns:
  a string representation of this map

#### equals

    public boolean equals(Object o)

Compares the specified object with this map for equality. Returns `true` if the given object is a map with the same mappings as this map. This operation may return misleading results if either map is concurrently modified during execution of this method.

Specified by:
  `equals` in interface `Map<K,V>`
Overrides:
  `equals` in class `Object`
Parameters:
  `o` - object to be compared for equality with this map
Returns:
  `true` if the specified object is equal to this map

2015 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 1.4.0
Release Date | : September 24 2015